# CesiumTerrainProvider

#### new Cesium.CesiumTerrainProvider(options)
engine/Source/Core/CesiumTerrainProvider.js 476

To construct a CesiumTerrainProvider, call `CesiumTerrainProvider.fromIonAssetId` or `CesiumTerrainProvider.fromUrl`. Do not call the constructor directly.
A `TerrainProvider` that accesses terrain data in a Cesium terrain format. Terrain formats can be one of the following:

- Quantized Mesh
- Height Map

Name | Type | Description
--- | --- | ---
`options` | CesiumTerrainProvider.ConstructorOptions | optional An object describing initialization options

##### Example:

    // Create Arctic DEM terrain with normals.
    try {
      const viewer = new Cesium.Viewer("cesiumContainer", {
        terrainProvider: await Cesium.CesiumTerrainProvider.fromIonAssetId(3956, {
          requestVertexNormals: true
        })
      });
    } catch (error) {
      console.log(error);
    }

##### See:

- createWorldTerrain
- CesiumTerrainProvider.fromUrl
- CesiumTerrainProvider.fromIonAssetId
- TerrainProvider

### Members

#### readonly availability : TileAvailability
engine/Source/Core/CesiumTerrainProvider.js 1138

Gets an object that can be used to determine availability of terrain from this provider, such as at points and in rectangles. This property may be undefined if availability information is not available. Note that this reflects tiles that are known to be available currently. Additional tiles may be discovered to be available in the future, e.g. if availability information exists deeper in the tree rather than it all being discoverable at the root. However, a tile that is available now will not become unavailable in the future.

#### readonly credit : Credit
engine/Source/Core/CesiumTerrainProvider.js 1027

Gets the credit to display when this terrain provider is active. Typically this is used to credit the source of the terrain.

#### readonly errorEvent : Event
engine/Source/Core/CesiumTerrainProvider.js 1014

Gets an event that is raised when the terrain provider encounters an asynchronous error. By subscribing to the event, you will be notified of the error and can potentially recover from it. Event listeners are passed an instance of `TileProviderError`.

#### readonly hasMetadata : boolean
engine/Source/Core/CesiumTerrainProvider.js 1078

Gets a value indicating whether or not the requested tiles include metadata.

#### readonly hasVertexNormals : boolean
engine/Source/Core/CesiumTerrainProvider.js 1065

Gets a value indicating whether or not the requested tiles include vertex normals.

#### readonly hasWaterMask : boolean
engine/Source/Core/CesiumTerrainProvider.js 1053

Gets a value indicating whether or not the provider includes a water mask. The water mask indicates which areas of the globe are water rather than land, so they can be rendered as a reflective surface with animated waves.

#### readonly requestMetadata : boolean
engine/Source/Core/CesiumTerrainProvider.js 1121

Boolean flag that indicates if the client should request metadata from the server. Metadata is appended to the standard tile mesh data only if the client requests the metadata and if the server provides a metadata.

#### readonly requestVertexNormals : boolean
engine/Source/Core/CesiumTerrainProvider.js 1093

Boolean flag that indicates if the client should request vertex normals from the server. Vertex normals data is appended to the standard tile mesh data only if the client requests the vertex normals and if the server provides vertex normals.

#### readonly requestWaterMask : boolean
engine/Source/Core/CesiumTerrainProvider.js 1107

Boolean flag that indicates if the client should request a watermask from the server. Watermask data is appended to the standard tile mesh data only if the client requests the watermask and if the server provides a watermask.

#### readonly tilingScheme : GeographicTilingScheme
engine/Source/Core/CesiumTerrainProvider.js 1039

Gets the tiling scheme used by this provider.

### Methods

#### static Cesium.CesiumTerrainProvider.fromIonAssetId(assetId, options) → Promise.<CesiumTerrainProvider>
engine/Source/Core/CesiumTerrainProvider.js 1187

Creates a `TerrainProvider` from a Cesium ion asset ID that accesses terrain data in a Cesium terrain format Terrain formats can be one of the following:

- Quantized Mesh
- Height Map

Name | Type | Description
--- | --- | ---
`assetId` | number | The Cesium ion asset id.
`options` | CesiumTerrainProvider.ConstructorOptions | optional An object describing initialization options.

##### Returns:

##### Throws:

- RuntimeError : layer.json does not specify a format
- RuntimeError : layer.json specifies an unknown format
- RuntimeError : layer.json specifies an unsupported quantized-mesh version
- RuntimeError : layer.json does not specify a tiles property, or specifies an empty array
- RuntimeError : layer.json does not specify any tile URL templates

##### Example:

    // Create Arctic DEM terrain with normals.
    try {
      const viewer = new Cesium.Viewer("cesiumContainer", {
        terrainProvider: await Cesium.CesiumTerrainProvider.fromIonAssetId(3956, {
            requestVertexNormals: true
        })
      });
    } catch (error) {
      console.log(error);
    }

#### static Cesium.CesiumTerrainProvider.fromUrl(url, options) → Promise.<CesiumTerrainProvider>
engine/Source/Core/CesiumTerrainProvider.js 1227

Creates a `TerrainProvider` that accesses terrain data in a Cesium terrain format. Terrain formats can be one of the following:

- Quantized Mesh
- Height Map

Name | Type | Description
--- | --- | ---
`url` | Resource | String | Promise.<Resource> | Promise.<String> | The URL of the Cesium terrain server.
`options` | CesiumTerrainProvider.ConstructorOptions | optional An object describing initialization options.

##### Returns:

##### Throws:

- RuntimeError : layer.json does not specify a format
- RuntimeError : layer.json specifies an unknown format
- RuntimeError : layer.json specifies an unsupported quantized-mesh version
- RuntimeError : layer.json does not specify a tiles property, or specifies an empty array
- RuntimeError : layer.json does not specify any tile URL templates

##### Example:

    // Create Arctic DEM terrain with normals.
    try {
      const viewer = new Cesium.Viewer("cesiumContainer", {
        terrainProvider: await Cesium.CesiumTerrainProvider.fromUrl(
          Cesium.IonResource.fromAssetId(3956), {
            requestVertexNormals: true
        })
      });
    } catch (error) {
      console.log(error);
    }

#### getLevelMaximumGeometricError(level) → number
engine/Source/Core/CesiumTerrainProvider.js 1151

Gets the maximum geometric error allowed in a tile at a given level.

Name | Type | Description
--- | --- | ---
`level` | number | The tile level for which to get the maximum geometric error.

##### Returns:

The maximum geometric error.

#### getTileDataAvailable(x, y, level) → boolean|undefined
engine/Source/Core/CesiumTerrainProvider.js 1262

Determines whether data for a tile is available to be loaded.

Name | Type | Description
--- | --- | ---
`x` | number | The X coordinate of the tile for which to request geometry.
`y` | number | The Y coordinate of the tile for which to request geometry.
`level` | number | The level of the tile for which to request geometry.

##### Returns:

Undefined if not supported or availability is unknown, otherwise true or false.

#### loadTileDataAvailability(x, y, level) → undefined|Promise.<void>
engine/Source/Core/CesiumTerrainProvider.js 1300

Makes sure we load availability data for a tile

Name | Type | Description
--- | --- | ---
`x` | number | The X coordinate of the tile for which to request geometry.
`y` | number | The Y coordinate of the tile for which to request geometry.
`level` | number | The level of the tile for which to request geometry.

##### Returns:

Undefined if nothing need to be loaded or a Promise that resolves when all required tiles are loaded

#### requestTileGeometry(x, y, level, request) → Promise.<TerrainData>|undefined
engine/Source/Core/CesiumTerrainProvider.js 854

Requests the geometry for a given tile. The result must include terrain data and may optionally include a water mask and an indication of which child tiles are available.

Name | Type | Description
--- | --- | ---
`x` | number | The X coordinate of the tile for which to request geometry.
`y` | number | The Y coordinate of the tile for which to request geometry.
`level` | number | The level of the tile for which to request geometry.
`request` | Request | optional The request object. Intended for internal use only.

##### Returns:

A promise for the requested geometry. If this method returns undefined instead of a promise, it is an indication that too many requests are already pending and the request will be retried later.

### Type Definitions

#### Cesium.CesiumTerrainProvider.ConstructorOptions
engine/Source/Core/CesiumTerrainProvider.js 40

Initialization options for the CesiumTerrainProvider constructor

##### Properties:

Name | Type | Attributes | Default | Description
--- | --- | --- | --- | ---
`requestVertexNormals` | boolean | <optional> | false | Flag that indicates if the client should request additional lighting information from the server, in the form of per vertex normals if available.
`requestWaterMask` | boolean | <optional> | false | Flag that indicates if the client should request per tile water masks from the server, if available.
`requestMetadata` | boolean | <optional> | true | Flag that indicates if the client should request per tile metadata from the server, if available.
`ellipsoid` | Ellipsoid | <optional> |  | The ellipsoid. If not specified, the WGS84 ellipsoid is used.
`credit` | Credit | string | <optional> |  | A credit for the data source, which is displayed on the canvas.

Need help? The fastest way to get answers is from the community and team on the Cesium Forum.